; Test, ob Spezifikation bereichsbeschraenkt ist
(define bereichsbeschraenkt?
  (lambda (spezifikation)
    (all regel-bereichsbeschraenkt?
         (spezifikation->regeln spezifikation))))

; Regel bb, wenn keine Variable aus dem Kopf im Rumpf nicht vorkommt.
; Die Mengendifferenz Kopfatome\Rumpfatome muss leer sein.
(define regel-bereichsbeschraenkt?
  (lambda (regel)
    (let ((freie-variablen (variablen-listen-differenz (variablen-in-kopf (regel->kopf regel))
                                                       (variablen-in-rumpf (regel->rumpf regel)))))
      (if (not (null? freie-variablen))
          (for-each display
                    (cons "Der Kopf der Regel "
                          (unparse-regel regel
                                         (cons (if (= (length freie-variablen) 1)
                                                   " enthaelt die freie Variable "
                                                   " enthaelt die freien Variablen ")
                                               (unparse-with " und " unparse-variable freie-variablen
                                                             (list "." (string #\newline))))))))
      (null? freie-variablen))))

(define variablen-listen-differenz
  (lambda (liste1 liste2)
    (remove (variablen-liste-enthaelt? liste2) liste1)))

(define variablen-liste-enthaelt?
  (lambda (liste)
    (lambda (variable1)
      (any (lambda (variable2) (variable=? variable1 variable2))
           liste))))

(define variablen-listen-vereinigen
  (lambda (listen)
    (foldr (lambda (liste1 liste2)
             (append (variablen-listen-differenz liste1 liste2) liste2))
           '()
           listen)))

(define variablen-in-rumpf
  (lambda (rumpf)
    (variablen-in-atomliste (rumpf->atomformeln rumpf))))

(define variablen-in-kopf
  (lambda (kopf)
    (variablen-in-atomliste (kopf->atomformeln kopf))))

(define variablen-in-atomliste
  (lambda (atomformelliste)
    (variablen-listen-vereinigen (map variablen-in-atomformel atomformelliste))))
    
(define variablen-in-atomformel
  (lambda (atomformel)
    (variablen-in-termliste (atomformel->terme atomformel))))

(define variablen-in-termliste
  (lambda (termliste)
    (variablen-listen-vereinigen (map variablen-in-term termliste))))

(define variablen-in-term
  (lambda (term)
    (if (variable? term)
        (list term)
        (variablen-in-termliste (funktion->terme term)))))
