; Berechne aus der Liste der bis jetzt gueltigen Substitutionen und
; einer Atomformel eine neue Liste von Substitutionen, so dass jede
; Instanz der Atomformel in der Datenbasis enthalten ist.
(define neue-substitutionen
  (lambda (datenbasis)
    (lambda (substitutionen atomformel)
      (foldr (lambda (substitution neue-subst)
               (append (map (substitutionen-komponieren substitution)
                            (passende-substitutionen ((atomformel-instanziieren substitution) atomformel)
                                                     datenbasis))
                       neue-subst))
             '()
             substitutionen))))

; Liefere Liste von Substitutionen, die den Rumpf wahr machen bzgl. der Datenbasis
(define rumpf-erfuellt
  (lambda (rumpf datenbasis)
    (foldl (neue-substitutionen datenbasis)
           (list leere-substitution)
           (rumpf->atomformeln rumpf))))

; Test, ob irgendeine Atomformel im (grundinstanziierten!) Kopf schon in der Datenbasis enthalten ist
(define kopf-erfuellt?
  (lambda (datenbasis)
    (lambda (kopf)
      (any (atomformel-in-datenbasis? datenbasis)
           (kopf->atomformeln kopf)))))

; Liefere Liste der (grundinstanziierten!) ableitbaren Koepfe einer Regel
(define versuche-regel
  (lambda (regel datenbasis trace?)
    (let ((kopf (regel->kopf regel)))
      (let ((koepfe (remove (kopf-erfuellt? datenbasis)
                            (map (lambda (substitution) ((kopf-instanziieren substitution) kopf))
                                 (rumpf-erfuellt (regel->rumpf regel) datenbasis)))))
        (if trace? (zeige-feuern regel koepfe))
        koepfe))))

; Liefere Liste der (grundinstanziierten!) ableitbaren Koepfe
(define ableitbare-koepfe
  (lambda (spezifikation datenbasis trace?)
    (foldl (lambda (koepfe regel) (append (versuche-regel regel datenbasis trace?) koepfe))
           '()
           (spezifikation->regeln spezifikation))))
