(define-record substitution (zuweisungen))
(define-record zuweisung (variable wert))

(define leere-substitution
  (make-substitution '()))

(define substitution-erweitern
  (lambda (variable wert substitution)
    (make-substitution (cons (make-zuweisung variable wert)
                             (substitution->zuweisungen substitution)))))

(define substitutionen-komponieren
  (lambda (substitution1)
    (lambda (substitution2)
      (foldr (lambda (zuweisung substitution)
               (substitution-erweitern (zuweisung->variable zuweisung)
                                       (zuweisung->wert zuweisung)
                                       substitution))
             substitution2
             (substitution->zuweisungen substitution1)))))

(define unparse-substitution
  (lambda (substitution accu)
    (cons "{"
          (unparse-with ", " unparse-zuweisung (substitution->zuweisungen substitution)
                        (cons "}" accu)))))

(define unparse-zuweisung
  (lambda (zuweisung accu)
    (unparse-term (zuweisung->wert zuweisung)
                  (cons "/" (unparse-variable (zuweisung->variable zuweisung) accu)))))

(define wert-von
  (lambda (variable substitution sc fc) 
    (letrec ((loop (lambda (zuweisungen)
                     (cond ((null? zuweisungen) (fc))
                           ((variable=? variable (zuweisung->variable (car zuweisungen)))
                            (sc (zuweisung->wert (car zuweisungen))))
                           (else (loop (cdr zuweisungen)))))))
      (loop (substitution->zuweisungen substitution)))))

(define regel-instanziieren
  (lambda (substitution)
    (lambda (regel)
      (make-regel ((rumpf-instanziieren substitution) (regel->rumpf regel))
                  ((kopf-instanziieren substitution) (regel->kopf regel))))))

(define rumpf-instanziieren
  (lambda (substitution)
    (lambda (rumpf)
      (make-rumpf (map (atomformel-instanziieren substitution) (rumpf->atomformeln rumpf))))))

(define kopf-instanziieren
  (lambda (substitution)
    (lambda (kopf)
      (make-kopf (map (atomformel-instanziieren substitution) (kopf->atomformeln kopf))))))

(define atomformel-instanziieren
  (lambda (substitution)
    (lambda (atomformel)
      (make-atomformel (atomformel->praedikatensymbol atomformel)
                       (map (term-instanziieren substitution) (atomformel->terme atomformel))))))

(define term-instanziieren
  (lambda (substitution)
    (lambda (term)
      (if (variable? term)
          ((variable-instanziieren substitution) term)
          ((funktion-instaziieren substitution) term)))))

(define variable-instanziieren
  (lambda (substitution)
    (lambda (variable)
      (wert-von variable substitution (lambda (wert) wert) (lambda () variable)))))

(define funktion-instaziieren
  (lambda (substitution)
    (lambda (funktion)
      (make-funktion (funktion->funktionssymbol funktion)
                     (map (term-instanziieren substitution) (funktion->terme funktion))))))
