(define newline-string (string #\newline))

(define zeige-koepfe
  (let ((unp (lambda (kopf accu)
               (if (null? (kopf->atomformeln kopf))
                   (cons "WIDERSPRUCH" accu)
                   (unparse-kopf kopf accu)))))
    (lambda (ueberschrift koepfe)
      (for-each display
                (cons ueberschrift
                      (cons newline-string
                            (unparse-with newline-string unp koepfe (list newline-string newline-string))))))))

(define spezifikation-ausgeben
  (let ((ueberschrift (string-append newline-string "Eingelesene Spezifikation:" newline-string)))
    (lambda (spezifikation)
      (for-each display
                (cons ueberschrift
                      (unparse-spezifikation spezifikation (list newline-string newline-string)))))))

(define datenbasis-ausgeben
  (lambda (ueberschrift datenbasis)
    (for-each display (append (list "------------------------------------------------------------"
                                    newline-string ueberschrift newline-string)
                              (unparse-datenbasis datenbasis (list newline-string newline-string))))))

(define zeige-subsumption
  (lambda (koepfe min-koepfe subsumieren?)
    (zeige-koepfe "***** Ableitbare Koepfe *****" koepfe)
    (if subsumieren?
        (if (= (length koepfe) (length min-koepfe))
            (begin (display "Nix subsumiert. Schade eigentlich...") (newline))
            (zeige-koepfe "****** Minimale Koepfe ******" min-koepfe)))))

(define zeige-feuern
  (lambda (regel koepfe)
    (if (not (null? koepfe))
        (zeige-koepfe (apply string-append (cons "FEUERN " (unparse-regel regel '())))
                      koepfe))))
