(define unparse-spezifikation
  (lambda (spezifikation accu)
    (unparse-with (string #\. #\newline) unparse-regel (spezifikation->regeln spezifikation) (cons "." accu))))

(define unparse-regel
  (lambda (regel accu)
    (unparse-rumpf (regel->rumpf regel)
                   (cons " --> " (unparse-kopf (regel->kopf regel) accu)))))

(define unparse-rumpf
  (lambda (rumpf accu)
    (unparse-with " & " unparse-atomformel (rumpf->atomformeln rumpf) accu)))

(define unparse-kopf
  (lambda (kopf accu)
    (unparse-with " ; " unparse-atomformel (kopf->atomformeln kopf) accu)))

(define unparse-atomformel
  (lambda (atomformel accu)
    (cons (praedikatensymbol->bezeichner (atomformel->praedikatensymbol atomformel))
          (unparse-terme (atomformel->terme atomformel) accu))))

(define unparse-terme
  (lambda (terme accu)
    (if (null? terme)
        accu
        (cons "("
              (unparse-with "," unparse-term terme (cons ")" accu))))))

(define unparse-term
  (lambda (term accu)
    ((if (variable? term) unparse-variable unparse-funktion) term accu)))

(define unparse-variable
  (lambda (variable accu)
    (cons (variable->bezeichner variable) accu)))

(define unparse-funktion
  (lambda (funktion accu)
    (cons (funktionssymbol->bezeichner (funktion->funktionssymbol funktion))
          (unparse-terme (funktion->terme funktion) accu))))

(define unparse-with
  (lambda (separator unparse-func liste accu)
    (if (null? liste)
        accu
        (let ((rest (unparse-with separator unparse-func (cdr liste) accu)))
          (unparse-func (car liste)
                        (if (null? (cdr liste))
                            rest
                            (cons separator rest)))))))
