(define identitaet (lambda (x) x))

(define konst
  (lambda (wert)
    (lambda argumente
      wert)))

; Zweistelliges Praedikat paarweise auf zwei Listen anwenden.
(define listen-gleich-mit?
  (lambda (praedikat liste1 liste2)
    (cond ((and (null? liste1) (null? liste2)) #t)
          ((or  (null? liste1) (null? liste2)) #f)
          (else (and (praedikat (car liste1) (car liste2))
                     (listen-gleich-mit? praedikat (cdr liste1) (cdr liste2)))))))

; Einstelliges Praedikat wahr fuer jedes Listenelement?
(define all
  (lambda (praedikat liste)
    (cond ((null? liste) #t)
          ((praedikat (car liste)) (all praedikat (cdr liste)))
          (else #f))))

; Einstelliges Praedikat wahr fuer mindestens ein Listenelement?
(define any
  (lambda (praedikat liste)
    (cond ((null? liste) #f)
          ((praedikat (car liste)) #t)
          (else (any praedikat (cdr liste))))))

; Liste mit Startwert ueber binaere Funktion "aufsammeln". Von links anfangen.
(define foldl
  (lambda (funktion grund-wert liste)
    (if (null? liste)
        grund-wert
        (foldl funktion (funktion grund-wert (car liste)) (cdr liste)))))

; Liste mit Startwert ueber binaere Funktion "aufsammeln". Von rechts anfangen.
(define foldr
  (lambda (funktion grund-wert liste)
    (if (null? liste)
        grund-wert
        (funktion (car liste)
                  (foldr funktion grund-wert (cdr liste))))))

; Listenelemente entfernen, fuer die ein Praedikat nicht erfuellt ist.
(define filter
  (lambda (praedikat liste)
    (foldr (lambda (element gefilterte-liste)
             (if (praedikat element)
                 (cons element gefilterte-liste)
                 gefilterte-liste))
           '()
           liste)))

; Komplement von filter
(define remove
  (lambda (praedikat liste)
    (filter (lambda (x) (not (praedikat x))) liste)))


; Neue Zeile beginnen nach der Ausgabe.
(define display-nl
  (lambda (text) (display text) (newline)))
