;--------------------------------------------------------------------------------
; Eine Zeichensequenz ist ein Strom

(define-syntax make-zeichen-sequenz
  (syntax-rules ()
    ((make-zeichen-sequenz zeichen sequenz)
     (cons-stream zeichen sequenz))))

(define zeichen-sequenz->kopf stream-car)
(define zeichen-sequenz->rest stream-cdr)
(define leere-zeichen-sequenz (stream))


;--------------------------------------------------------------------------------
; Konvertierung einer Datei in eine Zeichensequenz mit Terminierungszeichen

(define ende-zeichen (integer->char (- (char->integer #\space) 1)))

(define datei->zeichen-sequenz
  (lambda (datei-name)
    (letrec ((port (open-input-file datei-name))
             (loop (lambda ()
                     (let ((zeichen (read-char port)))
                       (cond ((eof-object? zeichen)
                              (close-input-port port)
                              (make-zeichen-sequenz ende-zeichen leere-zeichen-sequenz))
                             ((char=? zeichen ende-zeichen)
                              (error "Scanner: Ende-Zeichen in Eingabe" zeichen))
                             (else
                              (make-zeichen-sequenz zeichen (loop))))))))
      (loop))))

(define string->zeichen-sequenz
  (lambda (str)
    (letrec ((loop (lambda (liste)
                     (cond ((null? liste)
                            (make-zeichen-sequenz ende-zeichen leere-zeichen-sequenz))
                           ((char=? (car liste) ende-zeichen)
                            (error "Scanner: Ende-Zeichen in Eingabe" (car liste)))
                           (else
                            (make-zeichen-sequenz (car liste) (loop (cdr liste))))))))
      (loop (string->list str)))))
